---
title: "Creating a Basic Grid"
framework: javascript
version: "36.1.0"
---

# Creating a Basic Grid

Learn how to create and configure an AG Grid instance from scratch. This guide introduces the essential concepts required to build an interactive grid, including setting up row data, defining columns, applying grid options, formatting cell values, and adding custom components.

## Overview

In this tutorial you will:

1. [Create a basic grid](https://www.ag-grid.com/javascript-data-grid/deep-dive/#create-a-basic-grid)
2. [Load external data into the grid](https://www.ag-grid.com/javascript-data-grid/deep-dive/#load-new-data)
3. [Configure columns](https://www.ag-grid.com/javascript-data-grid/deep-dive/#configure-columns)
4. [Configure grid features](https://www.ag-grid.com/javascript-data-grid/deep-dive/#configure-the-grid)
5. [Format cell values](https://www.ag-grid.com/javascript-data-grid/deep-dive/#format-cell-values)
6. [Add custom components to cells](https://www.ag-grid.com/javascript-data-grid/deep-dive/#custom-cell-components)
7. [Hook into grid events](https://www.ag-grid.com/javascript-data-grid/deep-dive/#handle-grid-events)

Once complete, you'll have an interactive grid, with custom components and formatted data - Try it out for yourself by **sorting**, **filtering**, **resizing**, **selecting**, or **editing** data in the grid:

#### Testing Example

```ts
import {
  AllCommunityModule,
  CellValueChangedEvent,
  GridApi,
  GridOptions,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  SelectionChangedEvent,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Grid API: Access to Grid API methods
let gridApi: GridApi;

const dateFormatter = (params: ValueFormatterParams) => {
  return new Date(params.value).toLocaleDateString("en-us", {
    weekday: "long",
    year: "numeric",
    month: "short",
    day: "numeric",
  });
};

class CompanyLogoRenderer implements ICellRendererComp {
  eGui!: HTMLSpanElement;

  // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
  init(params: ICellRendererParams) {
    const companyLogo: HTMLImageElement = document.createElement("img");
    companyLogo.src = `https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`;
    companyLogo.setAttribute(
      "style",
      "display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1)",
    );

    const companyName: HTMLParagraphElement = document.createElement("p");
    companyName.textContent = params.value;
    companyName.setAttribute(
      "style",
      "text-overflow: ellipsis; overflow: hidden; white-space: nowrap;",
    );

    this.eGui = document.createElement("span");
    this.eGui.setAttribute(
      "style",
      "display: flex; height: 100%; width: 100%; align-items: center",
    );
    this.eGui.appendChild(companyLogo);
    this.eGui.appendChild(companyName);
  }

  // Required: Return the DOM element of the component, this is what the grid puts into the cell
  getGui() {
    return this.eGui;
  }

  // Required: Get the cell to refresh.
  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

class MissionResultRenderer implements ICellRendererComp {
  eGui!: HTMLSpanElement;

  // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
  init(params: ICellRendererParams) {
    const icon: HTMLImageElement = document.createElement("img");
    icon.src = `https://www.ag-grid.com/example-assets/icons/${params.value ? "tick-in-circle" : "cross-in-circle"}.png`;
    icon.setAttribute("style", "width: auto; height: auto;");

    this.eGui = document.createElement("span");
    this.eGui.setAttribute(
      "style",
      "display: flex; justify-content: center; height: 100%; align-items: center",
    );
    this.eGui.appendChild(icon);
  }

  // Required: Return the DOM element of the component, this is what the grid puts into the cell
  getGui() {
    return this.eGui;
  }

  // Required: Get the cell to refresh.
  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const gridOptions: GridOptions = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    {
      field: "mission",
      width: 150,
    },
    {
      field: "company",
      width: 130,
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
      width: 225,
    },
    {
      field: "date",
      valueFormatter: dateFormatter,
    },
    {
      field: "price",
      width: 130,
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    {
      field: "successful",
      width: 120,
      cellRenderer: MissionResultRenderer,
    },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    filter: true,
    editable: true,
  },
  // Grid Options & Callbacks
  pagination: true,
  rowSelection: { mode: "multiRow", headerCheckbox: false },
  onSelectionChanged: (event: SelectionChangedEvent) => {
    console.log("Row Selection Event!");
  },
  onCellValueChanged: (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`);
  },
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/typescript)

## Create a Basic Grid

Complete our [Quick Start](https://www.ag-grid.com/javascript-data-grid/getting-started/) (or open the example below in CodeSandbox / Plunker) to start with a basic grid, comprised of:

1. **Grid Options:** An object which holds all of the options for the grid, such as Row Data & Column Definitions.
2. **Row Data:** The data to be displayed.
3. **Column Definition:** Defines & controls grid columns.
4. **Container:** A div that contains and defines the grid's dimensions.
5. **Grid API:** Provides access to Grid API methods. Initialised when creating a new grid.

#### Basic Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  make: string;
  model: string;
  price: number;
  electric: boolean;
}

// Grid API: Access to Grid API methods
let gridApi: GridApi;

// Grid Options: Contains all of the grid configurations
const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
  ],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    { field: "make" },
    { field: "model" },
    { field: "price" },
    { field: "electric" },
  ],
};
// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);
```

[Live example: Basic Example](https://www.ag-grid.com/examples/deep-dive/basic-example/typescript)

## Load New Data

The Grid API provides a way of interacting with the grid. To update the data within the grid, we can use the `setGridOption` API. Let's test this by fetching some data and updating our grid with the response:

```jsx
fetch('https://www.ag-grid.com/example-assets/space-mission-data.json')
    .then(response => response.json())
    .then((data: any) => gridApi.setGridOption('rowData', data))
```

Now that we're loading data from an external source, we can empty our `rowData` array (which will allow the grid to display a loading spinner whilst the data is being fetched) and update our `colDefs` to match the new dataset:

```jsx
const gridOptions = {
    rowData: [],
    columnDefs: [
        { field: "mission" },
        { field: "company" },
        { field: "location" },
        { field: "date" },
        { field: "price" },
        { field: "successful" },
        { field: "rocket" }
    ]
}
```

When we run our application, we should see a grid with ~1,400 rows of new data, and new column headers to match:

#### Updating Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Grid API: Access to Grid API methods
let gridApi: GridApi;

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Grid Options: Contains all of the grid configurations
const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    { field: "mission" },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ],
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Updating Example](https://www.ag-grid.com/examples/deep-dive/updating-example/typescript)

*Note: There are a large number of APIs available. See our [API Docs](https://www.ag-grid.com/javascript-data-grid/grid-api/) for an exhaustive list.*

## Configure Columns

Now that we have a basic grid with some arbitrary data, we can start to configure the grid with ***Column Properties***.

Column Properties can be added to one or more columns to enable/disable column-specific features. Let's try this by adding the `filter: true` property to the 'mission' column:

```jsx
columnDefs: [
    { field: "mission", filter: true },
    // ...
],
```

We should now be able to filter the 'mission' column - you can test this by filtering for the 'Apollo' missions:

#### Configuring Columns Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Grid API: Access to Grid API methods
let gridApi: GridApi;

// Grid Options: Contains all of the grid configurations
const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ],
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Configuring Columns Example](https://www.ag-grid.com/examples/deep-dive/configure-columns-example/typescript)

*Note: Column properties can be used to configure a wide-range of features; refer to our [Column Properties](https://www.ag-grid.com/javascript-data-grid/column-properties/) page for a full list of features.*

### Default Column Definitions

The example above demonstrates how to configure a single column. To apply this configuration across all columns we can use ***Default Column Definitions*** instead. Let's make all of our columns filterable by adding the `defaultColDef` property to our Grid Options object, and setting `filter: true`:

```jsx
const gridOptions = {
    defaultColDef: {
        filter: true
    }
    // ...
}
```

The grid should now allow filtering on all columns:

#### Default Column Definitions Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Grid API: Access to Grid API methods
let gridApi: GridApi;

// Grid Options: Contains all of the grid configurations
const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    filter: true,
  },
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Default Column Definitions Example](https://www.ag-grid.com/examples/deep-dive/default-columns-example/typescript)

*Note: Column Definitions take precedence over Default Column Definitions*

## Configure The Grid

So far we've covered creating a grid, updating the data within the grid, and configuring columns. This section introduces **Grid Options**, which control functionality that extends across both rows & columns, such as Pagination and Row Selection.

To use Grid Options, simply add the relevant property to the Grid Options object. Let's try this by adding `pagination: true` to our Grid Options:

```jsx
const gridOptions: GridOptions = {
    pagination: true
    // ...
}
```

We should now see Pagination has been enabled on the grid:

#### Grid Options Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Grid API: Access to Grid API methods
let gridApi: GridApi;

// Grid Options: Contains all of the grid configurations
const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    filter: true,
  },
  // Grid Options
  pagination: true,
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Grid Options Example](https://www.ag-grid.com/examples/deep-dive/grid-options-example/typescript)

*Refer to our detailed [Grid Options](https://www.ag-grid.com/javascript-data-grid/grid-options/) documentation for a full list of options.*

## Format Cell Values

The data supplied to the grid usually requires some degree of formatting. For basic text formatting we can use **Value Formatters**.

**Value Formatters** are basic functions which take the value of the cell, apply some basic formatting, and return a new value to be displayed by the grid. Let's try this by adding the `valueFormatter` property to our 'price' column and returning the formatted value:

```jsx
columnDefs: [
    {
        field: "price",
        // Return formatted value
        valueFormatter: (params) => { return '£' + params.value.toLocaleString(); }
    },
],
```

The grid should now show the formatted value in the 'price' column:

#### Value Formatter Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Grid API: Access to Grid API methods
let gridApi: GridApi;

// Grid Options: Contains all of the grid configurations
const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    {
      field: "mission",
      filter: true,
    },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    filter: true,
  },
  // Grid Options
  pagination: true,
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Value Formatter Example](https://www.ag-grid.com/examples/deep-dive/value-formatter-example/typescript)

*Note: Read our [Value Formatter](https://www.ag-grid.com/javascript-data-grid/value-formatters/) page for more information on formatting cell values*

## Custom Cell Components

**Value Formatters** are useful for basic formatting, but for more advanced use-cases we can use **Cell Renderers** instead.

**Cell Renderers** allow you add custom HTML & JS within cells. To use a Cell Renderer, set the `cellRenderer` prop on a column, with the value as the name of your Cell Renderer.

Let's try this by creating a new component to display the company logo in the 'company' column:

```jsx
class CompanyLogoRenderer {
    eGui;

    // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
    init(params) {
        let companyLogo = document.createElement('img');
        companyLogo.src = `https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`
        companyLogo.setAttribute('style', 'display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1)');
        let companyName = document.createElement('p');
        companyName.textContent = params.value;
        companyName.setAttribute('style', 'text-overflow: ellipsis; overflow: hidden; white-space: nowrap;');
        this.eGui = document.createElement('span');
        this.eGui.setAttribute('style', 'display: flex; height: 100%; width: 100%; align-items: center')
        this.eGui.appendChild(companyLogo)
        this.eGui.appendChild(companyName)
    }

    // Required: Return the DOM element of the component, this is what the grid puts into the cell
    getGui() {
        return this.eGui;
    }

    // Required: Get the cell to refresh.
    refresh(params) {
        return false
    }
}
```

And then adding `cellRenderer: CompanyLogoRenderer` to the 'company' column definition:

```jsx
columnDefs: [
    {
        field: "company",
        cellRenderer: CompanyLogoRenderer
    },
    // ...
],
```

Now, when we run the grid, we should see a company logo next to the name:

#### Cell Renderer Example

```ts
import {
  AllCommunityModule,
  GridApi,
  GridOptions,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Grid API: Access to Grid API methods
let gridApi: GridApi;

class CompanyLogoRenderer implements ICellRendererComp {
  eGui!: HTMLSpanElement;

  // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
  init(params: ICellRendererParams) {
    const companyLogo: HTMLImageElement = document.createElement("img");
    companyLogo.src = `https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`;
    companyLogo.setAttribute(
      "style",
      "display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1)",
    );

    const companyName: HTMLParagraphElement = document.createElement("p");
    companyName.textContent = params.value;
    companyName.setAttribute(
      "style",
      "text-overflow: ellipsis; overflow: hidden; white-space: nowrap;",
    );

    this.eGui = document.createElement("span");
    this.eGui.setAttribute(
      "style",
      "display: flex; height: 100%; width: 100%; align-items: center",
    );
    this.eGui.appendChild(companyLogo);
    this.eGui.appendChild(companyName);
  }

  // Required: Return the DOM element of the component, this is what the grid puts into the cell
  getGui() {
    return this.eGui;
  }

  // Required: Get the cell to refresh.
  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    {
      field: "mission",
      filter: true,
    },
    {
      field: "company",
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
    },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    filter: true,
  },
  // Grid Options & Callbacks
  pagination: true,
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Cell Renderer Example](https://www.ag-grid.com/examples/deep-dive/cell-renderer-example/typescript)

*Note: Read our [Cell Components](https://www.ag-grid.com/javascript-data-grid/component-cell-renderer/) page for more information on using custom components in cells*

## Handle Grid Events

In the last section of this tutorial we're going to hook into events raised by the grid using ***Grid Events***.

To be notified of when an event is raised by the grid we need to add the relevant `on[EventName]` property to our Grid Options, and provide a function to handle the event.

Let's try this out by enabling cell editing in our DefaultColDefs with `editable: true` and hooking into the `onCellValueChanged` event to log the new value to the console:

```jsx
const gridOptions = {
    // Configurations applied to all columns
    defaultColDef: {
        editable: true,
        // ...
    },
    // Log new value when cell value changes
    onCellValueChanged: (event) => {
        console.log(`New Cell Value: ${event.value}`)
    }
    // ...
}
```

Now, when we click on a cell we should be able to edit it and see the new value logged to the console:

#### Complete Example

```ts
import {
  AllCommunityModule,
  CellValueChangedEvent,
  GridApi,
  GridOptions,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Grid API: Access to Grid API methods
let gridApi: GridApi;

class CompanyLogoRenderer implements ICellRendererComp {
  eGui!: HTMLSpanElement;

  // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
  init(params: ICellRendererParams) {
    const companyLogo: HTMLImageElement = document.createElement("img");
    companyLogo.src = `https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`;
    companyLogo.setAttribute(
      "style",
      "display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1)",
    );

    const companyName: HTMLParagraphElement = document.createElement("p");
    companyName.textContent = params.value;
    companyName.setAttribute(
      "style",
      "text-overflow: ellipsis; overflow: hidden; white-space: nowrap;",
    );

    this.eGui = document.createElement("span");
    this.eGui.setAttribute(
      "style",
      "display: flex; height: 100%; width: 100%; align-items: center",
    );
    this.eGui.appendChild(companyLogo);
    this.eGui.appendChild(companyName);
  }

  // Required: Return the DOM element of the component, this is what the grid puts into the cell
  getGui() {
    return this.eGui;
  }

  // Required: Get the cell to refresh.
  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const gridOptions: GridOptions<IRow> = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    {
      field: "mission",
      filter: true,
    },
    {
      field: "company",
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
    },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    editable: true,
    filter: true,
  },
  // Grid Options & Callbacks
  pagination: true,
  onCellValueChanged: (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`);
  },
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Complete Example](https://www.ag-grid.com/examples/deep-dive/grid-events-example/typescript)

*Refer to our [Grid Events](https://www.ag-grid.com/javascript-data-grid/grid-events/) documentation for a full list of events raised by the grid*

## Test Your Knowledge

Let's put what you've learned so far into action by modifying the grid:

1. Enable filtering on all columns

   *Hint: `filter` is a Column Definition property*
2. Enable multiple row selection

   *Hint: `rowSelection` is a Grid Option property*
3. Log a message to the console when a row selection is changed

   *Hint: `onSelectionChanged` is a Grid Event*
4. Format the Date column using `.toLocaleDateString()`;

   *Hint: Use a `valueFormatter` on the 'Date' column to format its value*
5. Add a Cell Renderer to display [ticks](https://www.ag-grid.com/example-assets/icons/tick-in-circle.png) and [crosses](https://www.ag-grid.com/example-assets/icons/cross-in-circle.png) in place of checkboxes on the 'Successful' column:

   *Hint: Use a `cellRenderer` on the 'successful' column*

Once complete, your grid should look like the example below. If you're stuck, check out the source code to see how its done:

#### Testing Example

```ts
import {
  AllCommunityModule,
  CellValueChangedEvent,
  GridApi,
  GridOptions,
  ICellRendererComp,
  ICellRendererParams,
  ModuleRegistry,
  SelectionChangedEvent,
  ValueFormatterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Grid API: Access to Grid API methods
let gridApi: GridApi;

const dateFormatter = (params: ValueFormatterParams) => {
  return new Date(params.value).toLocaleDateString("en-us", {
    weekday: "long",
    year: "numeric",
    month: "short",
    day: "numeric",
  });
};

class CompanyLogoRenderer implements ICellRendererComp {
  eGui!: HTMLSpanElement;

  // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
  init(params: ICellRendererParams) {
    const companyLogo: HTMLImageElement = document.createElement("img");
    companyLogo.src = `https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`;
    companyLogo.setAttribute(
      "style",
      "display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1)",
    );

    const companyName: HTMLParagraphElement = document.createElement("p");
    companyName.textContent = params.value;
    companyName.setAttribute(
      "style",
      "text-overflow: ellipsis; overflow: hidden; white-space: nowrap;",
    );

    this.eGui = document.createElement("span");
    this.eGui.setAttribute(
      "style",
      "display: flex; height: 100%; width: 100%; align-items: center",
    );
    this.eGui.appendChild(companyLogo);
    this.eGui.appendChild(companyName);
  }

  // Required: Return the DOM element of the component, this is what the grid puts into the cell
  getGui() {
    return this.eGui;
  }

  // Required: Get the cell to refresh.
  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

class MissionResultRenderer implements ICellRendererComp {
  eGui!: HTMLSpanElement;

  // Optional: Params for rendering. The same params that are passed to the cellRenderer function.
  init(params: ICellRendererParams) {
    const icon: HTMLImageElement = document.createElement("img");
    icon.src = `https://www.ag-grid.com/example-assets/icons/${params.value ? "tick-in-circle" : "cross-in-circle"}.png`;
    icon.setAttribute("style", "width: auto; height: auto;");

    this.eGui = document.createElement("span");
    this.eGui.setAttribute(
      "style",
      "display: flex; justify-content: center; height: 100%; align-items: center",
    );
    this.eGui.appendChild(icon);
  }

  // Required: Return the DOM element of the component, this is what the grid puts into the cell
  getGui() {
    return this.eGui;
  }

  // Required: Get the cell to refresh.
  refresh(params: ICellRendererParams): boolean {
    return false;
  }
}

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const gridOptions: GridOptions = {
  // Data to be displayed
  rowData: [],
  // Columns to be displayed (Should match rowData properties)
  columnDefs: [
    {
      field: "mission",
      width: 150,
    },
    {
      field: "company",
      width: 130,
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
      width: 225,
    },
    {
      field: "date",
      valueFormatter: dateFormatter,
    },
    {
      field: "price",
      width: 130,
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    {
      field: "successful",
      width: 120,
      cellRenderer: MissionResultRenderer,
    },
    { field: "rocket" },
  ],
  // Configurations applied to all columns
  defaultColDef: {
    filter: true,
    editable: true,
  },
  // Grid Options & Callbacks
  pagination: true,
  rowSelection: { mode: "multiRow", headerCheckbox: false },
  onSelectionChanged: (event: SelectionChangedEvent) => {
    console.log("Row Selection Event!");
  },
  onCellValueChanged: (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`);
  },
};

// Create Grid: Create new grid within the #myGrid div, using the Grid Options object
gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

// Fetch Remote Data
fetch("https://www.ag-grid.com/example-assets/space-mission-data.json")
  .then((response) => response.json())
  .then((data: any) => gridApi.setGridOption("rowData", data));
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/typescript)

## Summary

Congratulations! You've completed the tutorial and built your first grid. By now, you should be familiar with the key concepts of AG Grid:

- **Row Data:** Your data, in JSON format, that you want the grid to display.
- **Column Definitions:** Define your columns and control column-specific functionality, like sorting and filtering.
- **Default Column Definitions:** Similar to Column Definitions, but applies configurations to all columns.
- **Grid Options:** Configure functionality which extends across the entire grid.
- **Grid Events:** Events raised by the grid, typically as a result of user interaction.
- **Value Formatters:** Functions used for basic text formatting
- **Cell Renderers:** Add your own components to cells

## Next Steps

Browse our guides to dive into specific features of the grid:

- [Theming & Styling](https://www.ag-grid.com/javascript-data-grid/theming/)
- [Testing](https://www.ag-grid.com/javascript-data-grid/testing/)
- [Security](https://www.ag-grid.com/javascript-data-grid/security/)


---
product: "AG Grid"
title: "Creating a Basic Grid"
description: "Learn to create and configure an AG Grid from scratch, covering row data, column definitions, grid options, formatting, and custom components."
framework: vue
version: "36.2.0"
related:
    - title: "Styling a Grid"
      url: "https://www.ag-grid.com/vue-data-grid/styling-tutorial/"
    - title: "Testing"
      url: "https://www.ag-grid.com/vue-data-grid/testing/"
    - title: "Video Tutorials"
      url: "https://www.youtube.com/watch?v=V14w_NFuZB4&list=PLsZlhayVgqNz5iC0wFQDgixcAepFyrWbP&pp=gAQB"
llms: "https://www.ag-grid.com/llms.txt"
---

# Creating a Basic Grid

Learn how to create and configure an AG Grid instance from scratch. This guide introduces the essential concepts required to build an interactive grid, including setting up row data, defining columns, applying grid options, formatting cell values, and adding custom components.

## Overview

In this tutorial you will:

1. [Create a basic grid](https://www.ag-grid.com/vue-data-grid/deep-dive/#create-a-basic-grid)
2. [Load external data into the grid](https://www.ag-grid.com/vue-data-grid/deep-dive/#load-new-data)
3. [Configure columns](https://www.ag-grid.com/vue-data-grid/deep-dive/#configure-columns)
4. [Configure grid features](https://www.ag-grid.com/vue-data-grid/deep-dive/#configure-the-grid)
5. [Format cell values](https://www.ag-grid.com/vue-data-grid/deep-dive/#format-cell-values)
6. [Add custom components to cells](https://www.ag-grid.com/vue-data-grid/deep-dive/#custom-cell-components)
7. [Hook into grid events](https://www.ag-grid.com/vue-data-grid/deep-dive/#handle-grid-events)

Once complete, you'll have an interactive grid, with custom components and formatted data - Try it out for yourself by **sorting**, **filtering**, **resizing**, **selecting**, or **editing** data in the grid:

#### Testing Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type {
  CellValueChangedEvent,
  ColDef,
  RowSelectionOptions,
  SelectionChangedEvent,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const CompanyLogoRenderer = {
  template: `
    <span style="display: flex; height: 100%; width: 100%; align-items: center;">
      <img :src="'https://www.ag-grid.com/example-assets/space-company-logos/' + cellValueLowerCase + '.png'" style="display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1);" />
      <p style="text-overflow: ellipsis; overflow: hidden; white-space: nowrap;">{{ cellValue }}</p>
    </span>
    `,
  setup(props) {
    const cellValue = props.params.value;
    const cellValueLowerCase = cellValue.toLowerCase();
    return {
      cellValue,
      cellValueLowerCase,
    };
  },
};

const MissionResultRenderer = {
  template: `
    <span style="display: flex; justify-content: center; height: 100%; align-items: center;">
      <img
        :alt="params.value"
        :src="'https://www.ag-grid.com/example-assets/icons/' + cellValue + '.png'"
        style="width: auto; height: auto;"
      />
    </span>
    `,
  setup(props) {
    const cellValue = props.params.value ? "tick-in-circle" : "cross-in-circle";
    return {
      cellValue,
    };
  },
};

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
    <ag-grid-vue
        style="width: 100%; height: 100%"
        :columnDefs="colDefs"
        :rowData="rowData"
        :defaultColDef="defaultColDef"
        :pagination="true"
        :rowSelection="rowSelection"
        @cell-value-changed="onCellValueChanged"
        @selection-changed="onSelectionChanged"
    >
    </ag-grid-vue>
    `,
  components: {
    AgGridVue,
    companyLogoRenderer: CompanyLogoRenderer,
    missionResultRenderer: MissionResultRenderer,
  },
  methods: {
    onCellValueChanged(event: CellValueChangedEvent) {
      console.log(`New Cell Value: ${event.value}`);
    },
    onSelectionChanged(event: SelectionChangedEvent) {
      console.log("Row Selection Event!");
    },
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const dateFormatter = (params) => {
      return new Date(params.value).toLocaleDateString("en-us", {
        weekday: "long",
        year: "numeric",
        month: "short",
        day: "numeric",
      });
    };

    const colDefs = ref<ColDef[]>([
      {
        field: "mission",
        width: 150,
      },
      {
        field: "company",
        width: 130,
        cellRenderer: "companyLogoRenderer",
      },
      {
        field: "location",
        width: 225,
      },
      {
        field: "date",
        valueFormatter: dateFormatter,
      },
      {
        field: "price",
        width: 130,
        valueFormatter: (params: ValueFormatterParams) => {
          return "£" + params.value.toLocaleString();
        },
      },
      {
        field: "successful",
        width: 120,
        cellRenderer: "missionResultRenderer",
      },
      { field: "rocket" },
    ]);

    const rowSelection = ref<RowSelectionOptions>({
      mode: "multiRow",
      headerCheckbox: false,
    });

    const defaultColDef = ref<ColDef>({
      filter: true,
      editable: true,
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      rowSelection,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/vue3/)

## Create a Basic Grid

Complete our [Quick Start](https://www.ag-grid.com/vue-data-grid/getting-started/) (or open the example below in CodeSandbox / Plunker) to start with a basic grid, comprised of:

1. **Row Data:** The data to be displayed.
2. **Column Definition:** Defines & controls grid columns.
3. **Grid Component:** The `ag-grid-vue` component, with Dimensions, Row Data, and Column Definition attributes

#### Basic Example

```ts
import { createApp, defineComponent, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  make: string;
  model: string;
  price: number;
  electric: boolean;
}

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
    <ag-grid-vue
        style="width: 100%; height: 100%"
        :columnDefs="colDefs"
        :rowData="rowData"
    >
    </ag-grid-vue>
    `,
  components: {
    AgGridVue,
  },
  setup() {
    const rowData = ref<IRow[]>([
      { make: "Tesla", model: "Model Y", price: 64950, electric: true },
      { make: "Ford", model: "F-Series", price: 33850, electric: false },
      { make: "Toyota", model: "Corolla", price: 29600, electric: false },
    ]);

    const colDefs = ref<ColDef<IRow>[]>([
      { field: "make" },
      { field: "model" },
      { field: "price" },
      { field: "electric" },
    ]);

    return {
      rowData,
      colDefs,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Basic Example](https://www.ag-grid.com/examples/deep-dive/basic-example/vue3/)

## Load New Data

As rowData is a managed property, any updates to its value will be reflected in the grid. Let's test this by fetching some data from an external server and updating rowData with the response.

```jsx
// Fetch data when the component is mounted
onMounted(async () => {
    rowData.value = await fetchData();
});

const fetchData = async () => {
    const response = await fetch('https://www.ag-grid.com/example-assets/space-mission-data.json');
    return response.json();
};
```

Now that we're loading data from an external source, we can empty our `rowData` array (which will allow the grid to display a loading spinner whilst the data is being fetched) and update our `colDefs` to match the new dataset:

```jsx
const App = {
    setup() {
        const rowData = ref([]);
        const colDefs = ref([
            { field: "mission" },
            { field: "company" },
            { field: "location" },
            { field: "date" },
            { field: "price" },
            { field: "successful" },
            { field: "rocket" }
        ]);
        // ...
    }
    // ...
}
```

When we run our application, we should see a grid with ~1,400 rows of new data, and new column headers to match:

#### Updating Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
        <ag-grid-vue
            style="width: 100%; height: 100%"
            :columnDefs="colDefs"
            :rowData="rowData"
        >
        </ag-grid-vue>
    `,
  components: {
    AgGridVue,
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      { field: "mission" },
      { field: "company" },
      { field: "location" },
      { field: "date" },
      { field: "price" },
      { field: "successful" },
      { field: "rocket" },
    ]);

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Updating Example](https://www.ag-grid.com/examples/deep-dive/updating-example/vue3/)

Note: All [Grid Option](https://www.ag-grid.com/vue-data-grid/grid-options/) properties tagged as 'managed' are automatically updated when their value changes.

## Configure Columns

Now that we have a basic grid with some arbitrary data, we can start to configure the grid with ***Column Properties***.

Column Properties can be added to one or more columns to enable/disable column-specific features. Let's try this by adding the `filter: true` property to the 'mission' column:

```jsx
const colDefs = ref([
    { field: "mission", filter: true },
    // ...
]);
```

We should now be able to filter the 'mission' column - you can test this by filtering for the 'Apollo' missions:

#### Configuring Columns Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
    <ag-grid-vue
        style="width: 100%; height: 100%"
        :columnDefs="colDefs"
        :rowData="rowData"
    >
    </ag-grid-vue>
    `,
  components: {
    AgGridVue,
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      { field: "mission", filter: true },
      { field: "company" },
      { field: "location" },
      { field: "date" },
      { field: "price" },
      { field: "successful" },
      { field: "rocket" },
    ]);

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Configuring Columns Example](https://www.ag-grid.com/examples/deep-dive/configure-columns-example/vue3/)

*Note: Column properties can be used to configure a wide-range of features; refer to our [Column Properties](https://www.ag-grid.com/vue-data-grid/column-properties/) page for a full list of features.*

### Default Column Definitions

The example above demonstrates how to configure a single column. To apply this configuration across all columns we can use ***Default Column Definitions*** instead. Let's make all of our columns filterable by creating a `defaultColDef` object with the property `filter: true`:

```jsx
const App = {
    setup() {
        const defaultColDef = ref({
            filter: true
        });
        // ...
        return {
            defaultColDef
            // ...
        };
    }
    // ...
}
```

And then adding this to our `ag-grid-vue` component:

```jsx
const App = {
    template:
        `
        <ag-grid-vue
            style="width: 100%; height: 100%"
            :columnDefs="colDefs"
            :rowData="rowData"
            :defaultColDef="defaultColDef"
        >
        </ag-grid-vue>
        `,
    // ...
}
```

The grid should now allow filtering on all columns:

#### Default Column Definitions Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
        <ag-grid-vue
            style="width: 100%; height: 100%"
            :columnDefs="colDefs"
            :rowData="rowData"
            :defaultColDef="defaultColDef"
        >
        </ag-grid-vue>
    `,
  components: {
    AgGridVue,
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      { field: "mission", filter: true },
      { field: "company" },
      { field: "location" },
      { field: "date" },
      { field: "price" },
      { field: "successful" },
      { field: "rocket" },
    ]);

    const defaultColDef = ref<ColDef>({
      filter: true,
    });

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Default Column Definitions Example](https://www.ag-grid.com/examples/deep-dive/default-columns-example/vue3/)

*Note: Column Definitions take precedence over Default Column Definitions*

## Configure The Grid

So far we've covered creating a grid, updating the data within the grid, and configuring columns. This section introduces **Grid Options**, which control functionality that extends across both rows & columns, such as Pagination and Row Selection.

Grid Options are added directly to the `ag-grid-vue` component. Let's test this out by adding the `:pagination="true"` to the grid:

```jsx
const App = {
    name: "App",
    template:
        `
        <ag-grid-vue
            style="width: 100%; height: 100%"
            :columnDefs="colDefs"
            :rowData="rowData"
            :defaultColDef="defaultColDef"
            :pagination="true"
        >
        </ag-grid-vue>
        `,
    //...
}
```

We should now see Pagination has been enabled on the grid:

#### Grid Options Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
    <ag-grid-vue
        style="width: 100%; height: 100%"
        :columnDefs="colDefs"
        :rowData="rowData"
        :defaultColDef="defaultColDef"
        :pagination="true"
    >
    </ag-grid-vue>
    `,
  components: {
    AgGridVue,
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      { field: "mission", filter: true },
      { field: "company" },
      { field: "location" },
      { field: "date" },
      { field: "price" },
      { field: "successful" },
      { field: "rocket" },
    ]);

    const defaultColDef = ref<ColDef>({
      filter: true,
    });

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Grid Options Example](https://www.ag-grid.com/examples/deep-dive/grid-options-example/vue3/)

*Refer to our detailed [Grid Options](https://www.ag-grid.com/vue-data-grid/grid-options/) documentation for a full list of options.*

## Format Cell Values

The data supplied to the grid usually requires some degree of formatting. For basic text formatting we can use **Value Formatters**.

**Value Formatters** are basic functions which take the value of the cell, apply some basic formatting, and return a new value to be displayed by the grid. Let's try this by adding the `valueFormatter` property to our 'price' column and returning the formatted value:

```jsx
const colDefs = ref([
    { field: "price", valueFormatter: (params) => { return params.value == null ? '' : '£' + params.value.toLocaleString(); } },
    // ...
]);
```

The grid should now show the formatted value in the 'price' column:

#### Value Formatter Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { ColDef, ValueFormatterParams } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
        <ag-grid-vue
            style="width: 100%; height: 100%"
            :columnDefs="colDefs"
            :rowData="rowData"
            :defaultColDef="defaultColDef"
            :pagination="true"
        >
        </ag-grid-vue>
    `,
  components: {
    AgGridVue,
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      {
        field: "mission",
        filter: true,
      },
      { field: "company" },
      { field: "location" },
      { field: "date" },
      {
        field: "price",
        valueFormatter: (params: ValueFormatterParams) => {
          return "£" + params.value.toLocaleString();
        },
      },
      { field: "successful" },
      { field: "rocket" },
    ]);

    const defaultColDef = ref<ColDef>({
      filter: true,
    });

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Value Formatter Example](https://www.ag-grid.com/examples/deep-dive/value-formatter-example/vue3/)

*Note: Read our [Value Formatter](https://www.ag-grid.com/vue-data-grid/value-formatters/) page for more information on formatting cell values*

## Custom Cell Components

**Value Formatters** are useful for basic formatting, but for more advanced use-cases we can use **Cell Renderers** instead.

**Cell Renderers** allow you to use your own components within cells. To use a custom component, set the `cellRenderer` prop on a column, with the value as the name of your component.

Let's try this by creating a new component to display the company logo in the 'company' column:

```jsx
const CompanyLogoRenderer = {
    template:
        `
        <span style="display: flex; height: 100%; width: 100%; align-items: center;">
            <img :src="'https://www.ag-grid.com/example-assets/space-company-logos/' + cellValueLowerCase + '.png'" style="display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1);" />
            <p style="text-overflow: ellipsis; overflow: hidden; white-space: nowrap;">{{ cellValue }}</p>
        </span>
        `,
    setup(props) {
        const cellValue = props.params.value;
        const cellValueLowerCase = cellValue.toLowerCase();
        return {
            cellValue,
            cellValueLowerCase
        };
    },
};
```

And then adding the `cellRenderer` property to the 'company' column:

```jsx
const App = {
    components: {
        AgGridVue,
        companyLogoRenderer: CompanyLogoRenderer
    },
    setup() {
        const colDefs = ref([
            { field: "company", cellRenderer: "companyLogoRenderer" },
            // ...
        ]);
        // ...
    }
    // ...
}
```

Now, when we run the grid, we should see a company logo next to the name:

#### Cell Renderer Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { ColDef, ValueFormatterParams } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const CompanyLogoRenderer = defineComponent({
  template: `
        <span style="display: flex; height: 100%; width: 100%; align-items: center;">
          <img :src="'https://www.ag-grid.com/example-assets/space-company-logos/' + cellValueLowerCase + '.png'" style="display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1);" />
          <p style="text-overflow: ellipsis; overflow: hidden; white-space: nowrap;">{{ cellValue }}</p>
        </span>
    `,
  setup(props) {
    const cellValue = props.params.value;
    const cellValueLowerCase = cellValue.toLowerCase();
    return {
      cellValue,
      cellValueLowerCase,
    };
  },
});

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
        <ag-grid-vue
            style="width: 100%; height: 100%"
            :columnDefs="colDefs"
            :rowData="rowData"
            :defaultColDef="defaultColDef"
            :pagination="true"
        >
        </ag-grid-vue>
    `,
  components: {
    AgGridVue,
    companyLogoRenderer: CompanyLogoRenderer,
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      {
        field: "mission",
        filter: true,
      },
      {
        field: "company",
        cellRenderer: "companyLogoRenderer",
      },
      { field: "location" },
      { field: "date" },
      {
        field: "price",
        valueFormatter: (params: ValueFormatterParams) => {
          return "£" + params.value.toLocaleString();
        },
      },
      { field: "successful" },
      { field: "rocket" },
    ]);

    const defaultColDef = ref<ColDef>({
      filter: true,
    });

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Cell Renderer Example](https://www.ag-grid.com/examples/deep-dive/cell-renderer-example/vue3/)

*Note: Read our [Cell Components](https://www.ag-grid.com/vue-data-grid/component-cell-renderer/) page for more information on using custom components in cells*

## Handle Grid Events

In the last section of this tutorial we're going to hook into events raised by the grid using ***Grid Events***.

To be notified of when an event is raised by the grid we need to use the relevant `@[event-name]` attribute on the `ag-grid-vue` component. Let's try this out by enabling cell editing with `editable: true` and hooking into the `onCellValueChanged` event to log the new value to the console:

```jsx
const App = {
    template:
        `
        <ag-grid-vue
            ...
            @cell-value-changed="onCellValueChanged"
        >
        </ag-grid-vue>
        `,
    methods: {
        onCellValueChanged(event) {
            console.log(`New Cell Value: ${event.value}`);
        }
    },
    setup() {
        const defaultColDef = ref({
            editable: true,
            // ...
        });
        // ...
    }
    // ...
}
```

Now, when we click on a cell we should be able to edit it and see the new value logged to the console:

#### Complete Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type { CellValueChangedEvent, ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  ValueFormatterParams,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const CompanyLogoRenderer = defineComponent({
  template: `
    <span style="display: flex; height: 100%; width: 100%; align-items: center;">
      <img :src="'https://www.ag-grid.com/example-assets/space-company-logos/' + cellValueLowerCase + '.png'" style="display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1);" />
      <p style="text-overflow: ellipsis; overflow: hidden; white-space: nowrap;">{{ cellValue }}</p>
    </span>
    `,
  setup(props) {
    const cellValue = props.params.value;
    const cellValueLowerCase = cellValue.toLowerCase();
    return {
      cellValue,
      cellValueLowerCase,
    };
  },
});

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
    <ag-grid-vue
        style="width: 100%; height: 100%"
        :columnDefs="colDefs"
        :rowData="rowData"
        :defaultColDef="defaultColDef"
        :pagination="true"
        @cell-value-changed="onCellValueChanged"
    >
    </ag-grid-vue>
    `,
  components: {
    AgGridVue,
    companyLogoRenderer: CompanyLogoRenderer,
  },
  methods: {
    onCellValueChanged(event: CellValueChangedEvent) {
      console.log(`New Cell Value: ${event.value}`);
    },
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    const colDefs = ref<ColDef[]>([
      {
        field: "mission",
        filter: true,
      },
      {
        field: "company",
        cellRenderer: "companyLogoRenderer",
      },
      {
        field: "location",
      },
      { field: "date" },
      {
        field: "price",
        valueFormatter: (params: ValueFormatterParams) => {
          return "£" + params.value.toLocaleString();
        },
      },
      { field: "successful" },
      { field: "rocket" },
    ]);

    const defaultColDef = ref<ColDef>({
      editable: true,
      filter: true,
    });

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Complete Example](https://www.ag-grid.com/examples/deep-dive/grid-events-example/vue3/)

*Refer to our [Grid Events](https://www.ag-grid.com/vue-data-grid/grid-events/) documentation for a full list of events raised by the grid*

## Test Your Knowledge

Let's put what you've learned so far into action by modifying the grid:

1. Enable filtering on all columns

   *Hint: `filter` is a Column Definition property*
2. Enable multiple row selection

   *Hint: `rowSelection` is a Grid Option property*
3. Log a message to the console when a row selection is changed

   *Hint: `onSelectionChanged` is a Grid Event*
4. Format the Date column using `.toLocaleDateString()`;

   *Hint: Use a `valueFormatter` on the 'Date' column to format its value*
5. Add a Cell Renderer to display [ticks](https://www.ag-grid.com/example-assets/icons/tick-in-circle.png) and [crosses](https://www.ag-grid.com/example-assets/icons/cross-in-circle.png) in place of checkboxes on the 'Successful' column:

   *Hint: Use a `cellRenderer` on the 'successful' column*

Once complete, your grid should look like the example below. If you're stuck, check out the source code to see how its done:

#### Testing Example

```ts
import { createApp, defineComponent, onMounted, ref } from "vue";

import type {
  CellValueChangedEvent,
  ColDef,
  RowSelectionOptions,
  SelectionChangedEvent,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const CompanyLogoRenderer = {
  template: `
    <span style="display: flex; height: 100%; width: 100%; align-items: center;">
      <img :src="'https://www.ag-grid.com/example-assets/space-company-logos/' + cellValueLowerCase + '.png'" style="display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.1);" />
      <p style="text-overflow: ellipsis; overflow: hidden; white-space: nowrap;">{{ cellValue }}</p>
    </span>
    `,
  setup(props) {
    const cellValue = props.params.value;
    const cellValueLowerCase = cellValue.toLowerCase();
    return {
      cellValue,
      cellValueLowerCase,
    };
  },
};

const MissionResultRenderer = {
  template: `
    <span style="display: flex; justify-content: center; height: 100%; align-items: center;">
      <img
        :alt="params.value"
        :src="'https://www.ag-grid.com/example-assets/icons/' + cellValue + '.png'"
        style="width: auto; height: auto;"
      />
    </span>
    `,
  setup(props) {
    const cellValue = props.params.value ? "tick-in-circle" : "cross-in-circle";
    return {
      cellValue,
    };
  },
};

// Define the component configuration
const App = defineComponent({
  name: "App",
  template: `
    <ag-grid-vue
        style="width: 100%; height: 100%"
        :columnDefs="colDefs"
        :rowData="rowData"
        :defaultColDef="defaultColDef"
        :pagination="true"
        :rowSelection="rowSelection"
        @cell-value-changed="onCellValueChanged"
        @selection-changed="onSelectionChanged"
    >
    </ag-grid-vue>
    `,
  components: {
    AgGridVue,
    companyLogoRenderer: CompanyLogoRenderer,
    missionResultRenderer: MissionResultRenderer,
  },
  methods: {
    onCellValueChanged(event: CellValueChangedEvent) {
      console.log(`New Cell Value: ${event.value}`);
    },
    onSelectionChanged(event: SelectionChangedEvent) {
      console.log("Row Selection Event!");
    },
  },
  setup() {
    const rowData = ref<IRow[]>([]);

    // Fetch data when the component is mounted
    onMounted(async () => {
      rowData.value = await fetchData();
    });

    const dateFormatter = (params) => {
      return new Date(params.value).toLocaleDateString("en-us", {
        weekday: "long",
        year: "numeric",
        month: "short",
        day: "numeric",
      });
    };

    const colDefs = ref<ColDef[]>([
      {
        field: "mission",
        width: 150,
      },
      {
        field: "company",
        width: 130,
        cellRenderer: "companyLogoRenderer",
      },
      {
        field: "location",
        width: 225,
      },
      {
        field: "date",
        valueFormatter: dateFormatter,
      },
      {
        field: "price",
        width: 130,
        valueFormatter: (params: ValueFormatterParams) => {
          return "£" + params.value.toLocaleString();
        },
      },
      {
        field: "successful",
        width: 120,
        cellRenderer: "missionResultRenderer",
      },
      { field: "rocket" },
    ]);

    const rowSelection = ref<RowSelectionOptions>({
      mode: "multiRow",
      headerCheckbox: false,
    });

    const defaultColDef = ref<ColDef>({
      filter: true,
      editable: true,
    });

    const fetchData = async () => {
      const response = await fetch(
        "https://www.ag-grid.com/example-assets/space-mission-data.json",
      );
      return response.json();
    };

    return {
      rowData,
      colDefs,
      rowSelection,
      defaultColDef,
    };
  },
});

createApp(App).mount("#app");
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/vue3/)

## Summary

Congratulations! You've completed the tutorial and built your first grid. By now, you should be familiar with the key concepts of AG Grid:

- **Row Data:** Your data, in JSON format, that you want the grid to display.
- **Column Definitions:** Define your columns and control column-specific functionality, like sorting and filtering.
- **Default Column Definitions:** Similar to Column Definitions, but applies configurations to all columns.
- **Grid Options:** Configure functionality which extends across the entire grid.
- **Grid Events:** Events raised by the grid, typically as a result of user interaction.
- **Value Formatters:** Functions used for basic text formatting
- **Cell Renderers:** Add your own components to cells

## Next Steps

Browse our guides to dive into specific features of the grid:

- [Theming & Styling](https://www.ag-grid.com/vue-data-grid/theming/)
- [Testing](https://www.ag-grid.com/vue-data-grid/testing/)
- [Security](https://www.ag-grid.com/vue-data-grid/security/)


---
product: "AG Grid"
title: "Creating a Basic Grid"
description: "Learn to create and configure an AG Grid from scratch, covering row data, column definitions, grid options, formatting, and custom components."
framework: react
version: "36.2.0"
related:
    - title: "Styling a Grid"
      url: "https://www.ag-grid.com/react-data-grid/styling-tutorial/"
    - title: "Best Practices"
      url: "https://www.ag-grid.com/react-data-grid/react-hooks/"
    - title: "Video Tutorials"
      url: "https://www.youtube.com/watch?v=6hxbPqziELk&list=PLsZlhayVgqNwHNHeqpCkSgdRV08xrKtzW&pp=gAQB"
llms: "https://www.ag-grid.com/llms.txt"
---

# Creating a Basic Grid

Learn how to create and configure an AG Grid instance from scratch. This guide introduces the essential concepts required to build an interactive grid, including setting up row data, defining columns, applying grid options, formatting cell values, and adding custom components.

## Overview

In this tutorial you will:

1. [Create a basic grid](https://www.ag-grid.com/react-data-grid/deep-dive/#create-a-basic-grid)
2. [Load external data into the grid](https://www.ag-grid.com/react-data-grid/deep-dive/#load-new-data)
3. [Configure columns](https://www.ag-grid.com/react-data-grid/deep-dive/#configure-columns)
4. [Configure grid features](https://www.ag-grid.com/react-data-grid/deep-dive/#configure-the-grid)
5. [Format cell values](https://www.ag-grid.com/react-data-grid/deep-dive/#format-cell-values)
6. [Add custom components to cells](https://www.ag-grid.com/react-data-grid/deep-dive/#custom-cell-components)
7. [Hook into grid events](https://www.ag-grid.com/react-data-grid/deep-dive/#handle-grid-events)

Once complete, you'll have an interactive grid, with custom components and formatted data - Try it out for yourself by **sorting**, **filtering**, **resizing**, **selecting**, or **editing** data in the grid:

#### Testing Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  RowSelectionOptions,
  ValueFormatterParams,
} from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Custom Cell Renderer (Display logos based on cell value)
const CompanyLogoRenderer = (params: CustomCellRendererProps) => (
  <span
    style={{
      display: "flex",
      height: "100%",
      width: "100%",
      alignItems: "center",
    }}
  >
    {params.value && (
      <img
        alt={`${params.value} Flag`}
        src={`https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`}
        style={{
          display: "block",
          width: "25px",
          height: "auto",
          maxHeight: "50%",
          marginRight: "12px",
          filter: "brightness(1.1)",
        }}
      />
    )}
    <p
      style={{
        textOverflow: "ellipsis",
        overflow: "hidden",
        whiteSpace: "nowrap",
      }}
    >
      {params.value}
    </p>
  </span>
);

/* Custom Cell Renderer (Display tick / cross in 'Successful' column) */
const MissionResultRenderer = (params: CustomCellRendererProps) => (
  <span
    style={{
      display: "flex",
      justifyContent: "center",
      height: "100%",
      alignItems: "center",
    }}
  >
    {
      <img
        alt={`${params.value}`}
        src={`https://www.ag-grid.com/example-assets/icons/${params.value ? "tick-in-circle" : "cross-in-circle"}.png`}
        style={{ width: "auto", height: "auto" }}
      />
    }
  </span>
);

/* Format Date Cells */
const dateFormatter = (params: ValueFormatterParams): string => {
  return new Date(params.value).toLocaleDateString("en-us", {
    weekday: "long",
    year: "numeric",
    month: "short",
    day: "numeric",
  });
};

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const rowSelection: RowSelectionOptions = {
  mode: "multiRow",
  headerCheckbox: false,
};

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    {
      field: "mission",
      width: 150,
    },
    {
      field: "company",
      width: 130,
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
      width: 225,
    },
    {
      field: "date",
      valueFormatter: dateFormatter,
    },
    {
      field: "price",
      width: 130,
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    {
      field: "successful",
      width: 120,
      cellRenderer: MissionResultRenderer,
    },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
      editable: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
          pagination={true}
          rowSelection={rowSelection}
          onSelectionChanged={(event) => console.log("Row Selected!")}
          onCellValueChanged={(event) =>
            console.log(`New Cell Value: ${event.value}`)
          }
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/reactFunctionalTs/)

## Create a Basic Grid

Complete our [Quick Start](https://www.ag-grid.com/react-data-grid/getting-started/) (or open the example below in CodeSandbox / Plunker) to start with a basic grid, comprised of:

1. **Row Data:** The data to be displayed.
2. **Column Definition:** Defines & controls grid columns.
3. **Container:** A div that contains the grid and defines its dimensions.
4. **Grid Component:** The `AgGridReact` component with **Row Data** and **Column Definition** props.

#### Basic Example

```tsx
'use client';
// React Grid Logic
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";

// Theme
import type { ColDef } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
// Core CSS
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Row Data Interface
interface IRow {
  make: string;
  model: string;
  price: number;
  electric: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const [rowData, setRowData] = useState<IRow[]>([
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
  ]);

  // Column Definitions: Defines & controls grid columns.
  const [colDefs, setColDefs] = useState<ColDef<IRow>[]>([
    { field: "make" },
    { field: "model" },
    { field: "price" },
    { field: "electric" },
  ]);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        <AgGridReact rowData={rowData} columnDefs={colDefs} />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Basic Example](https://www.ag-grid.com/examples/deep-dive/basic-example/reactFunctionalTs/)

*Note: `rowData` and `columnDefs` arrays use the `useState` hook. We recommend `useState` if the data is mutable, otherwise `useMemo` is preferable. Read our [Best Practices](https://www.ag-grid.com/react-data-grid/react-hooks/) guide to learn more about using React hooks with AG Grid.*

## Load New Data

As `rowData` is a reactive property, any updates to its state will be reflected in the grid. Let's test this by fetching some data from an external server and updating `rowData` with the response:

```jsx
// Fetch data & update rowData state
useEffect(() => {
    fetch('https://www.ag-grid.com/example-assets/space-mission-data.json') // Fetch data from server
        .then(result => result.json()) // Convert to JSON
        .then(rowData => setRowData(rowData)); // Update state of `rowData`
}, [])
```

Now that we're loading data from an external source, we can empty our `rowData` array (which will allow the grid to display a loading spinner whilst the data is being fetched) and update our `colDefs` to match the new dataset:

```jsx
const GridExample = () => {
    // Row Data: The data to be displayed.
    const [rowData, setRowData] = useState([]);
    const [colDefs, setColDefs] = useState([
        { field: "mission" },
        { field: "company" },
        { field: "location" },
        { field: "date" },
        { field: "price" },
        { field: "successful" },
        { field: "rocket" }
    ]);
    // ...
}
```

When we run our application, we should see a grid with ~1,400 rows of new data, and new column headers to match:

#### Updating Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    { field: "mission" },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact rowData={data} loading={loading} columnDefs={colDefs} />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Updating Example](https://www.ag-grid.com/examples/deep-dive/updating-example/reactFunctionalTs/)

*Note: All properties that are not tagged as 'initial' are reactive. See our [API docs](https://www.ag-grid.com/react-data-grid/grid-options/) for a complete list.*

## Configure Columns

Now that we have a basic grid with some arbitrary data, we can start to configure the grid with ***Column Properties***.

Column Properties can be added to one or more columns to enable/disable column-specific features. Let's try this by adding the `filter: true` property to the 'mission' column:

```jsx
const [colDefs] = useState([
    { field: "mission", filter: true },
    // ...
]);
```

We should now be able to filter the 'mission' column - you can test this by filtering for the 'Apollo' missions:

#### Configuring Columns Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact rowData={data} loading={loading} columnDefs={colDefs} />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Configuring Columns Example](https://www.ag-grid.com/examples/deep-dive/configure-columns-example/reactFunctionalTs/)

*Note: Column properties can be used to configure a wide-range of features; refer to our [Column Properties](https://www.ag-grid.com/react-data-grid/column-properties/) page for a full list of features.*

### Default Column Definitions

The example above demonstrates how to configure a single column. To apply this configuration across all columns we can use ***Default Column Definitions*** instead. Let's make all of our columns filterable by creating a `defaultColDef` object, setting `filter: true`, and passing this to the grid via the `defaultColDef` prop:

```jsx
// Apply settings across all columns
const defaultColDef = useMemo(() => ({
    filter: true // Enable filtering on all columns
}))

<div style={{ width: 600, height: 500 }}>
    <AgGridReact
        defaultColDef={defaultColDef}
        //...
    />
</div>
```

The grid should now allow filtering on all columns:

#### Default Column Definitions Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Default Column Definitions Example](https://www.ag-grid.com/examples/deep-dive/default-columns-example/reactFunctionalTs/)

*Note: Column Definitions take precedence over Default Column Definitions*

## Configure The Grid

So far we've covered creating a grid, updating the data within the grid, and configuring columns. This section introduces **Grid Options**, which control functionality that extends across both rows & columns, such as Pagination and Row Selection.

Grid Options are passed to the grid component directly as props. Let's enable pagination by adding `pagination={true}`:

```jsx
<div style={{ width: 600, height: 500 }}>
    <AgGridReact
        // ...
        pagination={true} // Enable Pagination
    />
</div>
```

We should now see Pagination has been enabled on the grid:

#### Grid Options Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
          pagination={true}
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Grid Options Example](https://www.ag-grid.com/examples/deep-dive/grid-options-example/reactFunctionalTs/)

*Refer to our detailed [Grid Options](https://www.ag-grid.com/react-data-grid/grid-options/) documentation for a full list of options.*

## Format Cell Values

The data supplied to the grid usually requires some degree of formatting. For basic text formatting we can use **Value Formatters**.

**Value Formatters** are basic functions which take the value of the cell, apply some basic formatting, and return a new value to be displayed by the grid. Let's try this by adding the `valueFormatter` property to our 'price' column and returning the formatted value:

```jsx
const [colDefs] = useState([
    {
        field: "price",
        // Return a formatted string for this column
        valueFormatter: params => { return params.value == null ? '' : '£' + params.value.toLocaleString(); }
    },
    // ...
]);
```

The grid should now show the formatted value in the 'price' column:

#### Value Formatter Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, ValueFormatterParams } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    {
      field: "mission",
      filter: true,
    },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
          pagination={true}
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Value Formatter Example](https://www.ag-grid.com/examples/deep-dive/value-formatter-example/reactFunctionalTs/)

*Note: Read our [Value Formatter](https://www.ag-grid.com/react-data-grid/value-formatters/) page for more information on formatting cell values*

## Custom Cell Components

**Value Formatters** are useful for basic formatting, but for more advanced use-cases we can use **Cell Renderers** instead.

**Cell Renderers** allow you to use your own React components within cells. To use a custom component, set the `cellRenderer` prop on a column, with the value as the name of your component.

Let's try this by creating a new component to display the company logo in the 'company' column:

```jsx
// Custom Cell Renderer (Display flags based on cell value)
const CompanyLogoRenderer = ({ value }) => (
    <span style={{ display: "flex", height: "100%", width: "100%", alignItems: "center" }}>{value && <img alt={`${value} Flag`} src={`https://www.ag-grid.com/example-assets/space-company-logos/${value.toLowerCase()}.png`} style={{display: "block", width: "25px", height: "auto", maxHeight: "50%", marginRight: "12px", filter: "brightness(1.1)"}} />}<p style={{ textOverflow: "ellipsis", overflow: "hidden", whiteSpace: "nowrap" }}>{value}</p></span>
);
```

And then adding the `cellRenderer` prop on our 'company' column to use our component:

```jsx
const [colDefs] = useState([
    {
        field: "company",
        // Add component to column via cellRenderer
        cellRenderer: CompanyLogoRenderer
    },
    // ...
]);
```

Now, when we run the grid, we should see a company logo next to the name:

#### Cell Renderer Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, ValueFormatterParams } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Custom Cell Renderer (Display logos based on cell value)
const CompanyLogoRenderer = (params: CustomCellRendererProps) => (
  <span
    style={{
      display: "flex",
      height: "100%",
      width: "100%",
      alignItems: "center",
    }}
  >
    {params.value && (
      <img
        alt={`${params.value} Flag`}
        src={`https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`}
        style={{
          display: "block",
          width: "25px",
          height: "auto",
          maxHeight: "50%",
          marginRight: "12px",
          filter: "brightness(1.1)",
        }}
      />
    )}
    <p
      style={{
        textOverflow: "ellipsis",
        overflow: "hidden",
        whiteSpace: "nowrap",
      }}
    >
      {params.value}
    </p>
  </span>
);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    {
      field: "mission",
      filter: true,
    },
    {
      field: "company",
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
    },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
          pagination={true}
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Cell Renderer Example](https://www.ag-grid.com/examples/deep-dive/cell-renderer-example/reactFunctionalTs/)

*Note: Read our [Cell Components](https://www.ag-grid.com/react-data-grid/component-cell-renderer/) page for more information on using custom components in cells*

## Handle Grid Events

In the last section of this tutorial we're going to hook into events raised by the grid using ***Grid Events***.

To be notified of when an event is raised by the grid we need to use the relevant `on[EventName]` prop on the grid component. Let's try this out by enabling cell editing with `editable: true` and hooking into the `onCellValueChanged` event to log the new value to the console:

```jsx
const defaultColDef = useMemo(() => ({
    editable: true, // Enable editing on all cells
    // ...
}))

<div style={{ width: 600, height: 500 }}>
    <AgGridReact
        // Hook into CellValueChanged event and log value
        onCellValueChanged={event => console.log(`New Cell Value: ${event.value}`)}
        // ...
    />
</div>
```

Now, when we click on a cell we should be able to edit it and see the new value logged to the console:

#### Complete Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, ValueFormatterParams } from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Custom Cell Renderer (Display logos based on cell value)
const CompanyLogoRenderer = (params: CustomCellRendererProps) => (
  <span
    style={{
      display: "flex",
      height: "100%",
      width: "100%",
      alignItems: "center",
    }}
  >
    {params.value && (
      <img
        alt={`${params.value} Flag`}
        src={`https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`}
        style={{
          display: "block",
          width: "25px",
          height: "auto",
          maxHeight: "50%",
          marginRight: "12px",
          filter: "brightness(1.1)",
        }}
      />
    )}
    <p
      style={{
        textOverflow: "ellipsis",
        overflow: "hidden",
        whiteSpace: "nowrap",
      }}
    >
      {params.value}
    </p>
  </span>
);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    {
      field: "mission",
      filter: true,
    },
    {
      field: "company",
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
    },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
      editable: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        {/* The AG Grid component, with Row Data & Column Definition props */}
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
          pagination={true}
          onCellValueChanged={(event) =>
            console.log(`New Cell Value: ${event.value}`)
          }
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Complete Example](https://www.ag-grid.com/examples/deep-dive/grid-events-example/reactFunctionalTs/)

*Refer to our [Grid Events](https://www.ag-grid.com/react-data-grid/grid-events/) documentation for a full list of events raised by the grid*

## Test Your Knowledge

Let's put what you've learned so far into action by modifying the grid:

1. Enable filtering on all columns

   *Hint: `filter` is a Column Definition property*
2. Enable multiple row selection

   *Hint: `rowSelection` is a Grid Option property*
3. Log a message to the console when a row selection is changed

   *Hint: `onSelectionChanged` is a Grid Event*
4. Format the Date column using `.toLocaleDateString()`;

   *Hint: Use a `valueFormatter` on the 'Date' column to format its value*
5. Add a Cell Renderer to display [ticks](https://www.ag-grid.com/example-assets/icons/tick-in-circle.png) and [crosses](https://www.ag-grid.com/example-assets/icons/cross-in-circle.png) in place of checkboxes on the 'Successful' column:

   *Hint: Use a `cellRenderer` on the 'successful' column*

Once complete, your grid should look like the example below. If you're stuck, check out the source code to see how its done:

#### Testing Example

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
// React Grid Logic
import React, { StrictMode, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  RowSelectionOptions,
  ValueFormatterParams,
} from "ag-grid-community";
import { AllCommunityModule } from "ag-grid-community";
import type { CustomCellRendererProps } from "ag-grid-react";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

// Custom Cell Renderer (Display logos based on cell value)
const CompanyLogoRenderer = (params: CustomCellRendererProps) => (
  <span
    style={{
      display: "flex",
      height: "100%",
      width: "100%",
      alignItems: "center",
    }}
  >
    {params.value && (
      <img
        alt={`${params.value} Flag`}
        src={`https://www.ag-grid.com/example-assets/space-company-logos/${params.value.toLowerCase()}.png`}
        style={{
          display: "block",
          width: "25px",
          height: "auto",
          maxHeight: "50%",
          marginRight: "12px",
          filter: "brightness(1.1)",
        }}
      />
    )}
    <p
      style={{
        textOverflow: "ellipsis",
        overflow: "hidden",
        whiteSpace: "nowrap",
      }}
    >
      {params.value}
    </p>
  </span>
);

/* Custom Cell Renderer (Display tick / cross in 'Successful' column) */
const MissionResultRenderer = (params: CustomCellRendererProps) => (
  <span
    style={{
      display: "flex",
      justifyContent: "center",
      height: "100%",
      alignItems: "center",
    }}
  >
    {
      <img
        alt={`${params.value}`}
        src={`https://www.ag-grid.com/example-assets/icons/${params.value ? "tick-in-circle" : "cross-in-circle"}.png`}
        style={{ width: "auto", height: "auto" }}
      />
    }
  </span>
);

/* Format Date Cells */
const dateFormatter = (params: ValueFormatterParams): string => {
  return new Date(params.value).toLocaleDateString("en-us", {
    weekday: "long",
    year: "numeric",
    month: "short",
    day: "numeric",
  });
};

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

const rowSelection: RowSelectionOptions = {
  mode: "multiRow",
  headerCheckbox: false,
};

// Create new GridExample component
const GridExample = () => {
  // Row Data: The data to be displayed.
  const { data, loading } = useFetchJson<IRow>(
    "https://www.ag-grid.com/example-assets/space-mission-data.json",
  );

  // Column Definitions: Defines & controls grid columns.
  const [colDefs] = useState<ColDef[]>([
    {
      field: "mission",
      width: 150,
    },
    {
      field: "company",
      width: 130,
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
      width: 225,
    },
    {
      field: "date",
      valueFormatter: dateFormatter,
    },
    {
      field: "price",
      width: 130,
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    {
      field: "successful",
      width: 120,
      cellRenderer: MissionResultRenderer,
    },
    { field: "rocket" },
  ]);

  // Apply settings across all columns
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      filter: true,
      editable: true,
    };
  }, []);

  // Container: Defines the grid's theme & dimensions.
  return (
    <AgGridProvider modules={[AllCommunityModule]}>
      <div style={{ width: "100%", height: "100%" }}>
        <AgGridReact
          rowData={data}
          loading={loading}
          columnDefs={colDefs}
          defaultColDef={defaultColDef}
          pagination={true}
          rowSelection={rowSelection}
          onSelectionChanged={(event) => console.log("Row Selected!")}
          onCellValueChanged={(event) =>
            console.log(`New Cell Value: ${event.value}`)
          }
        />
      </div>
    </AgGridProvider>
  );
};

// Render GridExample
const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/reactFunctionalTs/)

## Summary

Congratulations! You've completed the tutorial and built your first grid. By now, you should be familiar with the key concepts of AG Grid:

- **Row Data:** Your data, in JSON format, that you want the grid to display.
- **Column Definitions:** Define your columns and control column-specific functionality, like sorting and filtering.
- **Default Column Definitions:** Similar to Column Definitions, but applies configurations to all columns.
- **Grid Options:** Configure functionality which extends across the entire grid.
- **Grid Events:** Events raised by the grid, typically as a result of user interaction.
- **Value Formatters:** Functions used for basic text formatting
- **Cell Renderers:** Add your own components to cells

## Next Steps

Browse our guides to dive into specific features of the grid:

- [Theming & Styling](https://www.ag-grid.com/react-data-grid/theming/)
- [Testing](https://www.ag-grid.com/react-data-grid/testing/)
- [Security](https://www.ag-grid.com/react-data-grid/security/)


---
title: "Creating a Basic Grid"
framework: angular
version: "36.1.0"
---

# Creating a Basic Grid

Learn how to create and configure an AG Grid instance from scratch. This guide introduces the essential concepts required to build an interactive grid, including setting up row data, defining columns, applying grid options, formatting cell values, and adding custom components.

## Overview

In this tutorial you will:

1. [Create a basic grid](https://www.ag-grid.com/angular-data-grid/deep-dive/#create-a-basic-grid)
2. [Load external data into the grid](https://www.ag-grid.com/angular-data-grid/deep-dive/#load-new-data)
3. [Configure columns](https://www.ag-grid.com/angular-data-grid/deep-dive/#configure-columns)
4. [Configure grid features](https://www.ag-grid.com/angular-data-grid/deep-dive/#configure-the-grid)
5. [Format cell values](https://www.ag-grid.com/angular-data-grid/deep-dive/#format-cell-values)
6. [Add custom components to cells](https://www.ag-grid.com/angular-data-grid/deep-dive/#custom-cell-components)
7. [Hook into grid events](https://www.ag-grid.com/angular-data-grid/deep-dive/#handle-grid-events)

Once complete, you'll have an interactive grid, with custom components and formatted data - Try it out for yourself by **sorting**, **filtering**, **resizing**, **selecting**, or **editing** data in the grid:

#### Testing Example

```ts
import { HttpClient } from "@angular/common/http";
import {
  ChangeDetectionStrategy,
  Component,
  computed,
  signal,
} from "@angular/core";

import type { ICellRendererAngularComp } from "ag-grid-angular";
import { AgGridAngular } from "ag-grid-angular";
import type {
  CellValueChangedEvent,
  ColDef,
  GridReadyEvent,
  ICellRendererParams,
  RowSelectionOptions,
  SelectionChangedEvent,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Custom Cell Renderer Component
@Component({
  selector: "app-mission-result-renderer",
  changeDetection: ChangeDetectionStrategy.OnPush,
  standalone: true,
  template: `
    <span>
      @if (value()) {
        <img
          [alt]="value()"
          [src]="
            'https://www.ag-grid.com/example-assets/icons/' + value() + '.png'
          "
          [height]="30"
        />
      }
    </span>
  `,
  styles: [
    "img { width: auto; height: auto; } span {display: flex; height: 100%; justify-content: center; align-items: center} ",
  ],
})
export class MissionResultRenderer implements ICellRendererAngularComp {
  value = signal("");
  agInit(params: ICellRendererParams): void {
    this.refresh(params);
  }

  refresh(params: ICellRendererParams): boolean {
    this.value.set(params.value ? "tick-in-circle" : "cross-in-circle");
    return true;
  }
}

// Custom Cell Renderer Component
@Component({
  selector: "app-company-logo-renderer",
  changeDetection: ChangeDetectionStrategy.OnPush,
  standalone: true,
  template: `
    <span>
      @if (value()) {
        <img
          [alt]="value()"
          [src]="
            'https://www.ag-grid.com/example-assets/space-company-logos/' +
            lowercase() +
            '.png'
          "
        />
        <p>{{ value() }}</p>
      }
    </span>
  `,
  styles: [
    "img {display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.2);} span {display: flex; height: 100%; width: 100%; align-items: center} p { text-overflow: ellipsis; overflow: hidden; white-space: nowrap }",
  ],
})
export class CompanyLogoRenderer implements ICellRendererAngularComp {
  value = signal("");
  lowercase = computed(() => this.value().toLowerCase());

  agInit(params: ICellRendererParams): void {
    this.refresh(params);
  }

  refresh(params: ICellRendererParams): boolean {
    this.value.set(params.value);
    return true;
  }
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `
    <div class="content">
      <!-- The AG Grid component, with various Grid Option properties -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        [pagination]="true"
        [rowSelection]="rowSelection"
        (gridReady)="onGridReady($event)"
        (cellValueChanged)="onCellValueChanged($event)"
        (selectionChanged)="onSelectionChanged($event)"
      />
    </div>
  `,
})
export class AppComponent {
  // Return formatted date value
  dateFormatter(params: ValueFormatterParams) {
    return new Date(params.value).toLocaleDateString("en-us", {
      weekday: "long",
      year: "numeric",
      month: "short",
      day: "numeric",
    });
  }

  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    {
      field: "mission",
      width: 150,
    },
    {
      field: "company",
      width: 130,
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
      width: 225,
    },
    {
      field: "date",
      valueFormatter: this.dateFormatter,
    },
    {
      field: "price",
      width: 130,
      valueFormatter: (params) => {
        return "£" + params.value.toLocaleString();
      },
    },
    {
      field: "successful",
      width: 120,
      cellRenderer: MissionResultRenderer,
    },
    { field: "rocket" },
  ];

  rowSelection: RowSelectionOptions = {
    mode: "multiRow",
    headerCheckbox: false,
  };

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true, // Enable filtering on all columns
    editable: true, // Enable editing on all columns
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }

  // Handle row selection changed event
  onSelectionChanged = (event: SelectionChangedEvent) => {
    console.log("Row Selected!");
  };

  // Handle cell editing event
  onCellValueChanged = (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`);
  };
}
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/angular)

## Create a Basic Grid

Complete our [Quick Start](https://www.ag-grid.com/angular-data-grid/getting-started/) (or open the example below in CodeSandbox / Plunker) to start with a basic grid, comprised of:

1. **Row Data:** The data to be displayed.
2. **Column Definition:** Defines & controls grid columns.
3. **Grid Component:** The `ag-grid-angular` component, with Dimensions, Row Data, and Column Definition attributes

#### Basic Example

```ts
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  make: string;
  model: string;
  price: number;
  electric: boolean;
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 220px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
  ];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef<IRow>[] = [
    { field: "make" },
    { field: "model" },
    { field: "price" },
    { field: "electric" },
  ];
}
```

[Live example: Basic Example](https://www.ag-grid.com/examples/deep-dive/basic-example/angular)

## Load New Data

As rowData is a managed property, any updates to its value will be reflected in the grid. Let's test this by fetching some data from an external server with [Angular's HttpClient](https://angular.dev/guide/http) and updating rowData with the response.

First we need to hook into the `gridReady` event by adding `(gridReady)="onGridReady($event)"` to the `ag-grid-angular` component:

```html
<!-- The AG Grid component, with various Grid Option properties -->
<ag-grid-angular
    style="width: 100%; height: 550px;"
    [rowData]="rowData"
    [columnDefs]="colDefs"
    (gridReady)="onGridReady($event)"
/>
```

*Note: [Grid Events](https://www.ag-grid.com/angular-data-grid/deep-dive/#handle-grid-events) are covered in more detail later on*

And then executing a HTTP request when the onGridReady event is fired, subscribing to the result to update our rowData asynchronously:

```ts
// Load data into grid when ready
onGridReady(params: GridReadyEvent) {
    this.http
        .get<any[]>('https://www.ag-grid.com/example-assets/space-mission-data.json')
        .subscribe(data => this.rowData = data);
}
```

Finally, now that we're loading data from an external source, we can empty our `rowData` array (which will allow the grid to display a loading spinner whilst the data is being fetched) and update our `colDefs` to match the new dataset:

```jsx
export class AppComponent {
    // Row Data: The data to be displayed.
    rowData: IRow[] = [];
    colDefs: ColDef[] = [
        { field: "mission" },
        { field: "company" },
        { field: "location" },
        { field: "date" },
        { field: "price" },
        { field: "successful" },
        { field: "rocket" }
    ];
    // ...
}
```

When we run our application, we should see a grid with ~1,400 rows of new data, and new column headers to match:

#### Updating Example

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        (gridReady)="onGridReady($event)"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    { field: "mission" },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Updating Example](https://www.ag-grid.com/examples/deep-dive/updating-example/angular)

*Note: All [Grid Option](https://www.ag-grid.com/angular-data-grid/grid-options/) properties tagged as 'managed' are automatically updated when their value changes.*

## Configure Columns

Now that we have a basic grid with some arbitrary data, we can start to configure the grid with ***Column Properties***.

Column Properties can be added to one or more columns to enable/disable column-specific features. Let's try this by adding the `filter: true` property to the 'mission' column:

```jsx
colDefs: ColDef[] = [
    { field: "mission", filter: true },
    // ...
];
```

We should now be able to filter the 'mission' column - you can test this by filtering for the 'Apollo' missions:

#### Configuring Columns Example

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        (gridReady)="onGridReady($event)"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Configuring Columns Example](https://www.ag-grid.com/examples/deep-dive/configure-columns-example/angular)

*Note: Column properties can be used to configure a wide-range of features; refer to our [Column Properties](https://www.ag-grid.com/angular-data-grid/column-properties/) page for a full list of features.*

### Default Column Definitions

The example above demonstrates how to configure a single column. To apply this configuration across all columns we can use ***Default Column Definitions*** instead. Let's make all of our columns filterable by creating a `defaultColDef` object, setting `filter: true`, and passing this to our template:

```jsx
@Component({
    template:
    `
    <div class="content">
        <ag-grid-angular
            ...
            [defaultColDef]="defaultColDef"
        />
    </div>
    `,
    // ...
})

export class AppComponent {
// Default Column Definitions: Apply configuration across all columns
defaultColDef: ColDef = {
        filter: true
    }
    // ...
}
```

The grid should now allow filtering on all columns:

#### Default Column Definitions Example

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        (gridReady)="onGridReady($event)"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    { field: "mission" },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true,
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Default Column Definitions Example](https://www.ag-grid.com/examples/deep-dive/default-columns-example/angular)

*Note: Column Definitions take precedence over Default Column Definitions*

## Configure The Grid

So far we've covered creating a grid, updating the data within the grid, and configuring columns. This section introduces **Grid Options**, which control functionality that extends across both rows & columns, such as Pagination and Row Selection.

Grid Options are passed to the grid via attributes on the `ag-grid-angular` component. Let's enable pagination by adding `[pagination]="true"`:

```html
<!-- The AG Grid component, with various Grid Option properties -->
<ag-grid-angular
    ...
    [pagination]="true"
/>
```

We should now see Pagination has been enabled on the grid:

#### Grid Options Example

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

@Component({
  standalone: true,
  selector: "my-app",
  imports: [AgGridAngular],
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        (gridReady)="onGridReady($event)"
        [pagination]="true"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    { field: "mission", filter: true },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    { field: "price" },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true,
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Grid Options Example](https://www.ag-grid.com/examples/deep-dive/grid-options-example/angular)

*Refer to our detailed [Grid Options](https://www.ag-grid.com/angular-data-grid/grid-options/) documentation for a full list of options.*

## Format Cell Values

The data supplied to the grid usually requires some degree of formatting. For basic text formatting we can use **Value Formatters**.

**Value Formatters** are basic functions which take the value of the cell, apply some basic formatting, and return a new value to be displayed by the grid. Let's try this by adding the `valueFormatter` property to our 'price' column and returning the formatted value:

```ts
colDefs: ColDef[] = [
    {
        field: "price",
        valueFormatter: params => { return '£' + params.value.toLocaleString(); } // Format with inline function
    },
    // ...
];
```

The grid should now show the formatted value in the 'price' column:

#### Value Formatter Example

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  GridReadyEvent,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        (gridReady)="onGridReady($event)"
        [pagination]="true"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    {
      field: "mission",
      filter: true,
    },
    { field: "company" },
    { field: "location" },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true,
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Value Formatter Example](https://www.ag-grid.com/examples/deep-dive/value-formatter-example/angular)

*Note: Read our [Value Formatter](https://www.ag-grid.com/angular-data-grid/value-formatters/) page for more information on formatting cell values*

## Custom Cell Components

**Value Formatters** are useful for basic formatting, but for more advanced use-cases we can use **Cell Renderers** instead.

**Cell Renderers** allow you to use your own components within cells. To use a custom component, add the `cellRenderer` prop to a column and set the value to the name of your component.

Let's try this by creating a new component to display the company logo in the 'company' column:

```jsx
// Custom Cell Renderer Component
@Component({
    selector: 'app-company-logo-renderer',
    standalone: true,
    template: `<span>@if(value){<img [alt]="value" [src]="'https://www.ag-grid.com/example-assets/space-company-logos/' + value.toLowerCase() + '.png'" /> <p>{{ value }}</p>}</span>`,
    styles: ["img {display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.2);} span {display: flex; height: 100%; width: 100%; align-items: center} p { text-overflow: ellipsis; overflow: hidden; white-space: nowrap }"]
    })

    export class CompanyLogoRenderer implements ICellRendererAngularComp {
    // Init Cell Value
    public value!: string;
    agInit(params: ICellRendererParams): void {
        this.value = params.value;
    }

    refresh(params: ICellRendererParams): boolean {
        this.value = params.value;
        return true;
    }
}
```

And then adding the cellRenderer prop on our 'company' column to use our component:

```ts
colDefs: ColDef[] = [
    {
        field: "company",
        cellRenderer: CompanyLogoRenderer // Render a custom component
    }
    // ...
];
```

Now, when we run the grid, we should see a company logo next to the name:

#### Cell Renderer Example

```ts
import { HttpClient } from "@angular/common/http";
import {
  ChangeDetectionStrategy,
  Component,
  computed,
  signal,
} from "@angular/core";

import type { ICellRendererAngularComp } from "ag-grid-angular";
import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  GridReadyEvent,
  ICellRendererParams,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Custom Cell Renderer Component
@Component({
  selector: "app-company-logo-renderer",
  changeDetection: ChangeDetectionStrategy.OnPush,
  standalone: true,
  template: `
    <span>
      @if (value()) {
        <img
          [alt]="value()"
          [src]="
            'https://www.ag-grid.com/example-assets/space-company-logos/' +
            lowercase() +
            '.png'
          "
        />
        <p>{{ value() }}</p>
      }
    </span>
  `,
  styles: [
    "img {display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.2);} span {display: flex; height: 100%; width: 100%; align-items: center} p { text-overflow: ellipsis; overflow: hidden; white-space: nowrap }",
  ],
})
export class CompanyLogoRenderer implements ICellRendererAngularComp {
  value = signal("");
  lowercase = computed(() => this.value().toLowerCase());

  agInit(params: ICellRendererParams): void {
    this.value.set(params.value);
  }

  refresh(params: ICellRendererParams): boolean {
    this.value.set(params.value);
    return true;
  }
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        (gridReady)="onGridReady($event)"
        [pagination]="true"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    {
      field: "mission",
      filter: true,
    },
    {
      field: "company",
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
    },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true,
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Cell Renderer Example](https://www.ag-grid.com/examples/deep-dive/cell-renderer-example/angular)

*Note: Read our [Cell Components](https://www.ag-grid.com/angular-data-grid/component-cell-renderer/) page for more information on using custom components in cells*

## Handle Grid Events

In the last section of this tutorial we're going to hook into events raised by the grid using ***Grid Events***.

To be notified of when an event is raised by the grid we need to add the relevant event name attribute to the `ag-grid-angular` component.

Let's try this out by enabling cell editing with `editable: true` on the Default Column Definitions:

```ts
// Default Column Definitions: Apply configuration across all columns
defaultColDef: ColDef = {
    editable: true
    // ...
}
```

Next, lets create a function to handle the event:

```jsx
// Handle cell editing event
onCellValueChanged = (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`)
}
```

Finally, let's add the `cellValueChanged` attribute to the `ag-grid-angular` component, with the value as the function we've just created:

```ts
<!-- The AG Grid component, with various Grid Option properties -->
<ag-grid-angular
    (cellValueChanged)="onCellValueChanged($event)"
    ...
/>
```

Now, when we click on a cell we should be able to edit it and see the new value logged to the console:

#### Complete Example

```ts
import { HttpClient } from "@angular/common/http";
import {
  ChangeDetectionStrategy,
  Component,
  computed,
  signal,
} from "@angular/core";

import type { ICellRendererAngularComp } from "ag-grid-angular";
import { AgGridAngular } from "ag-grid-angular";
import type {
  CellValueChangedEvent,
  ColDef,
  GridReadyEvent,
  ICellRendererParams,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Custom Cell Renderer Component
@Component({
  selector: "app-company-logo-renderer",
  changeDetection: ChangeDetectionStrategy.OnPush,
  standalone: true,
  template: `
    <span>
      @if (value()) {
        <img
          [alt]="value()"
          [src]="
            'https://www.ag-grid.com/example-assets/space-company-logos/' +
            lowercase() +
            '.png'
          "
        />
        <p>{{ value() }}</p>
      }
    </span>
  `,
  styles: [
    "img {display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.2);} span {display: flex; height: 100%; width: 100%; align-items: center} p { text-overflow: ellipsis; overflow: hidden; white-space: nowrap }",
  ],
})
export class CompanyLogoRenderer implements ICellRendererAngularComp {
  value = signal("");
  lowercase = computed(() => this.value().toLowerCase());

  agInit(params: ICellRendererParams): void {
    this.value.set(params.value);
  }

  refresh(params: ICellRendererParams): boolean {
    this.value.set(params.value);
    return true;
  }
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="content">
      <!-- The AG Grid component, with Dimensions, CSS Theme, Row Data, and Column Definition -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        [pagination]="true"
        (gridReady)="onGridReady($event)"
        (cellValueChanged)="onCellValueChanged($event)"
      />
    </div>
  `,
})
export class AppComponent {
  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    {
      field: "mission",
      filter: true,
    },
    {
      field: "company",
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
    },
    { field: "date" },
    {
      field: "price",
      valueFormatter: (params: ValueFormatterParams) => {
        return "£" + params.value.toLocaleString();
      },
    },
    { field: "successful" },
    { field: "rocket" },
  ];

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true,
    editable: true,
  };

  // Handle cell editing event
  onCellValueChanged = (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`);
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Complete Example](https://www.ag-grid.com/examples/deep-dive/grid-events-example/angular)

*Refer to our [Grid Events](https://www.ag-grid.com/angular-data-grid/grid-events/) documentation for a full list of events raised by the grid*

## Test Your Knowledge

Let's put what you've learned so far into action by modifying the grid:

1. Enable filtering on all columns

   *Hint: `filter` is a Column Definition property*
2. Enable multiple row selection

   *Hint: `rowSelection` is a Grid Option property*
3. Log a message to the console when a row selection is changed

   *Hint: `onSelectionChanged` is a Grid Event*
4. Format the Date column using `.toLocaleDateString()`;

   *Hint: Use a `valueFormatter` on the 'Date' column to format its value*
5. Add a Cell Renderer to display [ticks](https://www.ag-grid.com/example-assets/icons/tick-in-circle.png) and [crosses](https://www.ag-grid.com/example-assets/icons/cross-in-circle.png) in place of checkboxes on the 'Successful' column:

   *Hint: Use a `cellRenderer` on the 'successful' column*

Once complete, your grid should look like the example below. If you're stuck, check out the source code to see how its done:

#### Testing Example

```ts
import { HttpClient } from "@angular/common/http";
import {
  ChangeDetectionStrategy,
  Component,
  computed,
  signal,
} from "@angular/core";

import type { ICellRendererAngularComp } from "ag-grid-angular";
import { AgGridAngular } from "ag-grid-angular";
import type {
  CellValueChangedEvent,
  ColDef,
  GridReadyEvent,
  ICellRendererParams,
  RowSelectionOptions,
  SelectionChangedEvent,
  ValueFormatterParams,
} from "ag-grid-community";
import {
  AllCommunityModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([AllCommunityModule]);

// Row Data Interface
interface IRow {
  mission: string;
  company: string;
  location: string;
  date: string;
  time: string;
  rocket: string;
  price: number;
  successful: boolean;
}

// Custom Cell Renderer Component
@Component({
  selector: "app-mission-result-renderer",
  changeDetection: ChangeDetectionStrategy.OnPush,
  standalone: true,
  template: `
    <span>
      @if (value()) {
        <img
          [alt]="value()"
          [src]="
            'https://www.ag-grid.com/example-assets/icons/' + value() + '.png'
          "
          [height]="30"
        />
      }
    </span>
  `,
  styles: [
    "img { width: auto; height: auto; } span {display: flex; height: 100%; justify-content: center; align-items: center} ",
  ],
})
export class MissionResultRenderer implements ICellRendererAngularComp {
  value = signal("");
  agInit(params: ICellRendererParams): void {
    this.refresh(params);
  }

  refresh(params: ICellRendererParams): boolean {
    this.value.set(params.value ? "tick-in-circle" : "cross-in-circle");
    return true;
  }
}

// Custom Cell Renderer Component
@Component({
  selector: "app-company-logo-renderer",
  changeDetection: ChangeDetectionStrategy.OnPush,
  standalone: true,
  template: `
    <span>
      @if (value()) {
        <img
          [alt]="value()"
          [src]="
            'https://www.ag-grid.com/example-assets/space-company-logos/' +
            lowercase() +
            '.png'
          "
        />
        <p>{{ value() }}</p>
      }
    </span>
  `,
  styles: [
    "img {display: block; width: 25px; height: auto; max-height: 50%; margin-right: 12px; filter: brightness(1.2);} span {display: flex; height: 100%; width: 100%; align-items: center} p { text-overflow: ellipsis; overflow: hidden; white-space: nowrap }",
  ],
})
export class CompanyLogoRenderer implements ICellRendererAngularComp {
  value = signal("");
  lowercase = computed(() => this.value().toLowerCase());

  agInit(params: ICellRendererParams): void {
    this.refresh(params);
  }

  refresh(params: ICellRendererParams): boolean {
    this.value.set(params.value);
    return true;
  }
}

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `
    <div class="content">
      <!-- The AG Grid component, with various Grid Option properties -->
      <ag-grid-angular
        style="width: 100%; height: 550px;"
        [rowData]="rowData"
        [columnDefs]="colDefs"
        [defaultColDef]="defaultColDef"
        [pagination]="true"
        [rowSelection]="rowSelection"
        (gridReady)="onGridReady($event)"
        (cellValueChanged)="onCellValueChanged($event)"
        (selectionChanged)="onSelectionChanged($event)"
      />
    </div>
  `,
})
export class AppComponent {
  // Return formatted date value
  dateFormatter(params: ValueFormatterParams) {
    return new Date(params.value).toLocaleDateString("en-us", {
      weekday: "long",
      year: "numeric",
      month: "short",
      day: "numeric",
    });
  }

  // Row Data: The data to be displayed.
  rowData: IRow[] = [];

  // Column Definitions: Defines & controls grid columns.
  colDefs: ColDef[] = [
    {
      field: "mission",
      width: 150,
    },
    {
      field: "company",
      width: 130,
      cellRenderer: CompanyLogoRenderer,
    },
    {
      field: "location",
      width: 225,
    },
    {
      field: "date",
      valueFormatter: this.dateFormatter,
    },
    {
      field: "price",
      width: 130,
      valueFormatter: (params) => {
        return "£" + params.value.toLocaleString();
      },
    },
    {
      field: "successful",
      width: 120,
      cellRenderer: MissionResultRenderer,
    },
    { field: "rocket" },
  ];

  rowSelection: RowSelectionOptions = {
    mode: "multiRow",
    headerCheckbox: false,
  };

  // Default Column Definitions: Apply configuration across all columns
  defaultColDef: ColDef = {
    filter: true, // Enable filtering on all columns
    editable: true, // Enable editing on all columns
  };

  // Load data into grid when ready
  constructor(private http: HttpClient) {}
  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/space-mission-data.json")
      .subscribe((data) => (this.rowData = data));
  }

  // Handle row selection changed event
  onSelectionChanged = (event: SelectionChangedEvent) => {
    console.log("Row Selected!");
  };

  // Handle cell editing event
  onCellValueChanged = (event: CellValueChangedEvent) => {
    console.log(`New Cell Value: ${event.value}`);
  };
}
```

[Live example: Testing Example](https://www.ag-grid.com/examples/deep-dive/testing-example/angular)

## Summary

Congratulations! You've completed the tutorial and built your first grid. By now, you should be familiar with the key concepts of AG Grid:

- **Row Data:** Your data, in JSON format, that you want the grid to display.
- **Column Definitions:** Define your columns and control column-specific functionality, like sorting and filtering.
- **Default Column Definitions:** Similar to Column Definitions, but applies configurations to all columns.
- **Grid Options:** Configure functionality which extends across the entire grid.
- **Grid Events:** Events raised by the grid, typically as a result of user interaction.
- **Value Formatters:** Functions used for basic text formatting
- **Cell Renderers:** Add your own components to cells

## Next Steps

Browse our guides to dive into specific features of the grid:

- [Theming & Styling](https://www.ag-grid.com/angular-data-grid/theming/)
- [Testing](https://www.ag-grid.com/angular-data-grid/testing/)
- [Security](https://www.ag-grid.com/angular-data-grid/security/)
